/**********************************************************************
 *	ARM DISASM
 **********************************************************************
 */		char USAGE[]=

"*  ARM DISASM customized to GBA Ver0.1\n"
"   gF\n"
"C:> DISARM -Option FILENAME\n"
"   IvV\n"
"         -s<start address>  擪ԒnPUiŎw.\n"
"         -t                 SThumb߂ƌȂċtAZu.\n"
"         -m                 rbOGfBAR[h͂.\n"
;


#include "std.h"
#include <sys/stat.h>
#include "ansidecl.h"
#include "dis-asm.h"
#include "symbol.h"


long	lpeek(long adr);
//int	print_insn_little_arm (long memaddr,struct disassemble_info *info);

struct 	disassemble_info info;
long	filesize;
struct  stat statbuf;
long	startaddr=0;
long	endaddr=0;
int		bigarm=0;
int		is_thumb =0;


char	 hbuf[64];		// 00000000 00000000
unsigned int		 hbuf_adr;
unsigned int		 hbuf_dat;

char	 lbuf[128];		//					 mov	ax,3
char	 remarkbuf[128];//									;Rg.
char	*lbufp;

SYMBOL  lsymbol;
char    label[80];

pr_rem(form,val)
	char *form;
	char *val;
{
	vsprintf(remarkbuf,form,&val);
}

static prfun(stream,form,val)
	FILE *stream;
	char *form;
	char *val;
{
	vsprintf(lbufp,form,&val);lbufp+=strlen(lbufp);
}

static	unsigned long	chkbig(unsigned long data)
{
	if(bigarm) {
		return	(((data <<24L) & 0xff000000L) |
				 ((data << 8L) & 0x00ff0000L) |
				 ((data >> 8L) & 0x0000ff00L) |
				 ((data >>24L) & 0x000000ffL) );
	}
	return data;
}

static	long	seek_oldpos = (-1);

//
static	void	OptSeek(pos)
{
	if(	seek_oldpos != pos) {
		seek_oldpos = pos;
		Seek(ifp,pos);
	}
}

static	int	memfun(long adr,long *buf)
{
	long data;

	if( (adr>=startaddr) && (adr<endaddr) ) {
		OptSeek(adr - startaddr);
		Read(&data,sizeof(long));
		seek_oldpos += sizeof(long);

		*buf = data;
//		sprintf(lbufp,"%08x %08x\t",adr,chkbig(data));lbufp+=strlen(lbufp);
		hbuf_adr = adr;
		hbuf_dat = data;
		return 0;
	}else{
		return 1;
	}
}

static	void	errfun()
{
	//printf("errfun()\n");
}


static	int	pr_addr(long addr)
{
	if(find_symbol_by_adrs(&lsymbol,addr)) {
		char *name=lsymbol.name;
		char *p = label;
		while(*name) *p++ = *name++;
					 *p++ = 0;
		sprintf(lbufp," ;%s\n",label);lbufp+=strlen(lbufp);
	}
}

void set_ea(char *buf,long addr)
{
	if(find_symbol_by_adrs(&lsymbol,addr)) {
		char *name=lsymbol.name;
		char *p = label;
		while(*name) *p++ = *name++;
					 *p++ = 0;
		sprintf(buf,"%s",label);
	}else{
		sprintf(buf,"0x%08x",addr);
	}
}


static	void	prafun(long addr)
{
	sprintf(lbufp,"$%08x",addr);lbufp+=strlen(lbufp);
	pr_addr(addr);
}


static	dislarm_init()
{
	info.stream				= NULL;
	info.fprintf_func       = prfun;
	info.read_memory_func   = memfun;
	info.memory_error_func  = errfun;
	info.print_address_func = prafun;
}

int	dislarm(long memaddr)
{
	int oplen;
	lbufp=lbuf;
	remarkbuf[0]=0;

	if(find_symbol_by_adrs(&lsymbol,memaddr)) {
		char *name=lsymbol.name;
		char *p = label;
		while(*name) *p++ = *name++;
					 *p++ = 0;
		printf("                  %s:\n",label);
	}

	if(bigarm) {
		oplen = print_insn_big_arm (memaddr,&info);
	}else{
		oplen = print_insn_little_arm (memaddr,&info);
	}
	
	if(is_thumb) {
		if(oplen==2) {
			sprintf(hbuf ,"%08x %04x     "	,hbuf_adr+0x08000000,hbuf_dat & 0xffff);
		}else{
			sprintf(hbuf ,"%08x %04x %04x"	,hbuf_adr+0x08000000,hbuf_dat & 0xffff,hbuf_dat>>16);
		}
	}else{
			sprintf(hbuf ,"%08x %08x "		,hbuf_adr+0x08000000,chkbig(hbuf_dat));
	}
	
	if(remarkbuf[0]) {
		printf("%s\t%-48s %s\n"	,hbuf,lbuf,remarkbuf);
	}else{
		printf("%s\t%s\n"		,hbuf,lbuf);
	}
	if(is_crlf())
		printf("\n");
		
//	oplen = info.bytes_per_line;
	return oplen;
}

bfd_vma		bfd_getl32(const unsigned char *buffer)
{
	unsigned long *l=(unsigned long *) buffer;
	return *l;
}

bfd_vma		bfd_getb32(const unsigned char *buffer)
{
	return (((unsigned long )buffer[0]<<24L) |
			((unsigned long )buffer[1]<<16L) |
			((unsigned long )buffer[2]<< 8L) |
			((unsigned long )buffer[3]     ) )
	;
}

usage()
{
	printf(USAGE);
	exit(1);
}

/*
 *	s̓[eBeB
 */
int getln(char *buf,FILE *fp)
{
	int c;
	int l;
	l=0;
	while(1) {
		c=getc(fp);
		if(c==EOF)  return(EOF);/* EOF */
		if(c==0x0d) continue;
		if(c==0x0a) {
			*buf = 0;	/* EOL */
			return(0);	/* OK  */
		}
		*buf++ = c;l++;
		if(l>=255) {
			*buf = 0;
			return(1);	/* Too long line */
		}
	}
}
/*
 *	gqt[eBeB
 *
 *	addext(name,"EXE") ̂悤ɂĎg
 *	gqtĂ烊l[ɂȂ
 */
void addext(char *name,char *ext)
{
	char *p,*q;
	p=name;q=NULL;
	while( *p ) {
		if ( *p == '.' ) q=p;
		p++;
	}
	if(q==NULL) q=p;
	/*if( (p-q) >= 4) return;  ȂbugĂ*/
	strcpy(q,".");
	strcpy(q+1,ext);
}

/**********************************************************************
 *	V{t@C΂ǂݍ
 **********************************************************************
 */
void read_symbol(char *name)
{
	char mapname[80];
	char buf[256];
	char sym[256];
	char dum[256];
	SYMBOL symbol;
	long adr=0;

	strcpy(mapname,name);
	addext(mapname,"map");
	ifp=fopen(mapname,"rb");if(ifp!=NULL) {
		while(getln(buf,ifp)!=EOF) {
			if(sscanf(buf,"%x %s %s",&adr,sym,dum)==2) {
				symbol.adrs = adr;
				symbol.name = sym;
				reg_symbol(&symbol);
			/*	printf("#%s\n%x <%s>\n",buf,adr,sym);*/
			}
		}
		fclose(ifp);
	}
}



main(int argc,char **argv)
{
	long off;
	long adr;
	long oplen;
	
	Getopt(argc,argv);
	if(argc<2) usage();

	if(IsOpt('m')) bigarm=1;
	if(IsOpt('t')) is_thumb=1;
	if(IsOpt('s')) sscanf(Opt('s'),"%x",&startaddr);
	adr = startaddr;
	dislarm_init();

	init_symbol();
	read_symbol(argv[1]);

	stat(argv[1],&statbuf);
		filesize= statbuf.st_size;
		endaddr = startaddr + filesize;

	Ropen(argv[1]);
	
	off = 0;
	while(off<filesize) {
		oplen = dislarm(adr);
		adr += oplen;
		off += oplen;
	}
	
	Rclose();
}

